diff --git a/platform/linux-generic/Makefile.am b/platform/linux-generic/Makefile.am
index 1feecd3b2..b6e195555 100644
--- a/platform/linux-generic/Makefile.am
+++ b/platform/linux-generic/Makefile.am
@@ -172,13 +172,13 @@ __LIB__libodp_linux_la_SOURCES = \
 			   pktio/ring.c \
 			   odp_pkt_queue.c \
 			   odp_pool.c \
-			   odp_queue.c \
+			   odp_queue_basic.c \
 			   odp_queue_if.c \
 			   odp_queue_lf.c \
 			   odp_queue_scalable.c \
 			   odp_rwlock.c \
 			   odp_rwlock_recursive.c \
-			   odp_schedule.c \
+			   odp_schedule_basic.c \
 			   odp_schedule_if.c \
 			   odp_schedule_sp.c \
 			   odp_schedule_iquery.c \
diff --git a/platform/linux-generic/odp_queue.c b/platform/linux-generic/odp_queue_basic.c
similarity index 99%
rename from platform/linux-generic/odp_queue.c
rename to platform/linux-generic/odp_queue_basic.c
index a7933c9bb..0c0a11ec1 100644
--- a/platform/linux-generic/odp_queue.c
+++ b/platform/linux-generic/odp_queue_basic.c
@@ -790,7 +790,7 @@ static odp_queue_t queue_to_ext(queue_t q_int)
 }
 
 /* API functions */
-queue_api_t queue_default_api = {
+queue_api_t queue_basic_api = {
 	.queue_create = queue_create,
 	.queue_destroy = queue_destroy,
 	.queue_lookup = queue_lookup,
@@ -812,7 +812,7 @@ queue_api_t queue_default_api = {
 };
 
 /* Functions towards internal components */
-queue_fn_t queue_default_fn = {
+queue_fn_t queue_basic_fn = {
 	.init_global = queue_init_global,
 	.term_global = queue_term_global,
 	.init_local = queue_init_local,
diff --git a/platform/linux-generic/odp_queue_if.c b/platform/linux-generic/odp_queue_if.c
index e1cfc9445..d1c468485 100644
--- a/platform/linux-generic/odp_queue_if.c
+++ b/platform/linux-generic/odp_queue_if.c
@@ -12,15 +12,15 @@
 extern const queue_api_t queue_scalable_api;
 extern const queue_fn_t queue_scalable_fn;
 
-extern const queue_api_t queue_default_api;
-extern const queue_fn_t queue_default_fn;
+extern const queue_api_t queue_basic_api;
+extern const queue_fn_t queue_basic_fn;
 
 #ifdef ODP_SCHEDULE_SCALABLE
 const queue_api_t *queue_api = &queue_scalable_api;
 const queue_fn_t *queue_fn = &queue_scalable_fn;
 #else
-const queue_api_t *queue_api = &queue_default_api;
-const queue_fn_t *queue_fn = &queue_default_fn;
+const queue_api_t *queue_api = &queue_basic_api;
+const queue_fn_t *queue_fn = &queue_basic_fn;
 #endif
 
 odp_queue_t odp_queue_create(const char *name, const odp_queue_param_t *param)
diff --git a/platform/linux-generic/odp_schedule.c b/platform/linux-generic/odp_schedule_basic.c
similarity index 99%
rename from platform/linux-generic/odp_schedule.c
rename to platform/linux-generic/odp_schedule_basic.c
index a6581bed8..7195eedea 100644
--- a/platform/linux-generic/odp_schedule.c
+++ b/platform/linux-generic/odp_schedule_basic.c
@@ -1407,7 +1407,7 @@ static int schedule_num_grps(void)
 }
 
 /* Fill in scheduler interface */
-const schedule_fn_t schedule_default_fn = {
+const schedule_fn_t schedule_basic_fn = {
 	.status_sync = 0,
 	.pktio_start = schedule_pktio_start,
 	.thr_add = schedule_thr_add,
@@ -1429,7 +1429,7 @@ const schedule_fn_t schedule_default_fn = {
 };
 
 /* Fill in scheduler API calls */
-const schedule_api_t schedule_default_api = {
+const schedule_api_t schedule_basic_api = {
 	.schedule_wait_time       = schedule_wait_time,
 	.schedule                 = schedule,
 	.schedule_multi           = schedule_multi,
diff --git a/platform/linux-generic/odp_schedule_if.c b/platform/linux-generic/odp_schedule_if.c
index 71d4ee75c..4639ad737 100644
--- a/platform/linux-generic/odp_schedule_if.c
+++ b/platform/linux-generic/odp_schedule_if.c
@@ -12,8 +12,8 @@
 extern const schedule_fn_t schedule_sp_fn;
 extern const schedule_api_t schedule_sp_api;
 
-extern const schedule_fn_t schedule_default_fn;
-extern const schedule_api_t schedule_default_api;
+extern const schedule_fn_t schedule_basic_fn;
+extern const schedule_api_t schedule_basic_api;
 
 extern const schedule_fn_t schedule_iquery_fn;
 extern const schedule_api_t schedule_iquery_api;
@@ -31,8 +31,8 @@ const schedule_api_t *sched_api = &schedule_iquery_api;
 const schedule_fn_t  *sched_fn  = &schedule_scalable_fn;
 const schedule_api_t *sched_api = &schedule_scalable_api;
 #else
-const schedule_fn_t  *sched_fn  = &schedule_default_fn;
-const schedule_api_t *sched_api = &schedule_default_api;
+const schedule_fn_t  *sched_fn  = &schedule_basic_fn;
+const schedule_api_t *sched_api = &schedule_basic_api;
 #endif
 
 uint64_t odp_schedule_wait_time(uint64_t ns)